searchNodes=[{"doc":"Generates a post for the given repo.Examplemix nabo.gen.post first-post --repo MyRepoCommand line options--repo - the repo to which the post belongs","ref":"Mix.Tasks.Nabo.Gen.Post.html","title":"Mix.Tasks.Nabo.Gen.Post","type":"task"},{"doc":"Nabo is a simple, fast blog engine written in Elixir.Nabo is designed to be integrate-able to other components in your application like Phoenix or Plug. It does not include stuff like routing or html generating, but only focuses on one thing and does it well: manages your blog posts.PostPost is the heart of Nabo and is represented as Nabo.Post struct.You can keep your blog posts in any directories you like in the source code, but all posts should follow this format.metadata (JSON, mandatory) --- post excerpt (Markdown, optional) --- post body (Markdown, mandatory)Example{ &quot;title&quot;: &quot;First Nabo post&quot;, &quot;slug&quot;: &quot;first-post&quot;, &quot;published_at&quot;: &quot;2017-01-01T00:00:00Z&quot; } --- This is my first blog post created with Nabo. --- ### Section 1 My first blog post created with Nabo. ### Section 2 ...See Nabo.Post for more information.RepoTo access your blog posts, you need to create a repo.defmodule MyRepo do use Nabo.Repo, root: &quot;priv/posts&quot; endTo get all posts.posts = MyRepo.all()To get a post by its slug.{:ok, post} = MyRepo.get(&quot;first-post&quot;)See Nabo.Repo for more information.CompilerCompiler is where your posts being compiled.Nabo uses Nabo.Compilers.Markdown as the default compiler but you're free to have your own options and compilers. See the documentation of Nabo.Compilers.Markdown for more options.If you want to build your own compiler, see Nabo.Compiler for more information.","ref":"Nabo.html","title":"Nabo","type":"module"},{"doc":"A struct that represents post metadata.Represents metadata that specified in the top of the post.","ref":"Nabo.Metadata.html","title":"Nabo.Metadata","type":"module"},{"doc":"The behaviour to implement a parser in Nabo. It requires a parse/2 callback to be implemented.There are three kinds of parser for accordingly three components in a post: a front parser for metadata, an excerpt parser and finally a post body parser.By default Nabo uses JSON for post metadata and Markdown for excerpt and post body, but with these three parsers implemented, you can have these components in your most loved format.ExampleGiven a raw post like this.title,slug,published_at,draft Nabo,nabo,&quot;Monday, 15-Aug-2005 15:52:01 UTC&quot;,false --- This is a post body --- [heading]Heading 1[/heading] [b]bold[b] [i]italics[i] [url=https://www.wikipedia.org/]Wikipedia[/url]Implement a front ParserThe parse/2 function of a front parser has to return {:ok, %Nabo.Metadata{}}.defmodule MyFrontParser do @behaviour Nabo.Parser def parse(binary, options) do data = MyCSVParser.parse(binary, options) metadata = %Nabo.Metadata{ title: data[&quot;title&quot;], slug: data[&quot;slug&quot;], published_at: data[&quot;published_at&quot;], draft?: data[&quot;draft&quot;] } {:ok, metadata} end endImplement an excerpt parserdefmodule MyExcerptParser do def parse(binary, _options) do {:ok, binary} end endImplement a body parserdefmodule MyBodyParser do def parse(binary, options) do {:ok, MyBBCodeParser.parse(binary, options)} end endThen everything is ready to be configured in the repo.defmodule MyRepo do use Nabo.Repo, root: &quot;/path/to/posts&quot;, compiler: [ front_parser: {MyFrontParser, []}, excerpt_parser: {MyExcerptParser, []}, body_parser: {MyBodyParser, []}, ] end","ref":"Nabo.Parser.html","title":"Nabo.Parser","type":"behaviour"},{"doc":"Parses a input binary into the desired format.","ref":"Nabo.Parser.html#c:parse/2","title":"Nabo.Parser.parse/2","type":"callback"},{"doc":"A struct that represents a post.This struct represents a post with its metadata, excerpt and post body, returned by Nabo.Repo.FormatPost should be in this format:metadata (JSON, mandatory) --- post excerpt (Markdown, optional) --- post body (Markdown, mandatory)For example:{ &quot;title&quot;: &quot;Hello World&quot;, &quot;slug&quot;: &quot;hello-world&quot;, &quot;published_at&quot;: &quot;2017-01-01T00:00:00Z&quot; } --- Welcome to my blog! --- ### Hello there! This is the first post in my blog.Post excerpt is optional, so if you prefer not to have any excerpt, leave it blank or exclude it from your post.{ &quot;title&quot;: &quot;Hello World&quot;, &quot;slug&quot;: &quot;hello-world&quot;, &quot;published_at&quot;: &quot;2017-01-01T00:00:00Z&quot; } --- ### Hello there! This is the first post in my blog.","ref":"Nabo.Post.html","title":"Nabo.Post","type":"module"},{"doc":"","ref":"Nabo.Post.html#t:slug/0","title":"Nabo.Post.slug/0","type":"type"},{"doc":"","ref":"Nabo.Post.html#t:t/0","title":"Nabo.Post.t/0","type":"type"},{"doc":"Precompiles and provides interface to interact with your posts.defmodule MyRepo do use Nabo.Repo, root: &quot;priv/posts&quot; end posts = MyRepo.all {:ok, post} = MyRepo.get(&quot;foo&quot;) post = MyRepo.get!(&quot;foo&quot;)Can be configured with:defmodule MyRepo do use Nabo.Repo, root: &quot;priv/posts&quot;, compiler: [ split_pattern: &quot;&lt;&lt;---------&gt;&gt;&quot;, front_parser: {MyJSONParser, []}, excerpt_parser: {MyExcerptParser, []}, body_parser: {Nabo.Parser.Markdown, %Earmark.Options{smartypants: false}} ] end:root - the path to posts.:compiler - the compiler options, includes of four sub-options. See Nabo.Parser for instructions of how to implement a parser.:split_pattern - the delimeter that separates front-matter, excerpt and post body. This will be passed as the second argument in String.split/3.:front_parser - the options for parsing front matter, in {parser_module, parser_options} format. Parser options will be passed to parse/2 function in parser module. Defaults to {Nabo.Parser.Front, []}:excerpt_parser - the options for parsing post excerpt, in {parser_module, parser_options} format. Parser options will be passed to parse/2 function in parser module. Defaults to {Nabo.Parser.Markdown, []}:body_parser - the options for parsing post body, in {parser_module, parser_options} format. Parser options will be passed to parse/2 function in parser module. Defaults to {Nabo.Parser.Markdown, []}","ref":"Nabo.Repo.html","title":"Nabo.Repo","type":"behaviour"},{"doc":"Fetches all available posts in the repo.Exampleposts = MyRepo.all()","ref":"Nabo.Repo.html#c:all/0","title":"Nabo.Repo.all/0","type":"callback"},{"doc":"Fetches all availables post names in the repo.Exampleavailables = MyRepo.availables()","ref":"Nabo.Repo.html#c:availables/0","title":"Nabo.Repo.availables/0","type":"callback"},{"doc":"Exclude draft posts.Exampleposts = MyRepo.all() |&gt; MyRepo.exclude_draft()","ref":"Nabo.Repo.html#c:exclude_draft/1","title":"Nabo.Repo.exclude_draft/1","type":"callback"},{"doc":"Filter only posts published before a specified datetime.Exampleposts = MyRepo.all() |&gt; MyRepo.filter_published()","ref":"Nabo.Repo.html#c:filter_published/2","title":"Nabo.Repo.filter_published/2","type":"callback"},{"doc":"Finds a post by the given slug.ExampleMyRepo.get(&quot;my-slug&quot;)","ref":"Nabo.Repo.html#c:get/1","title":"Nabo.Repo.get/1","type":"callback"},{"doc":"Similar to get/1 but raises error when no post is found.Examplepost = MyRepo.get!(&quot;my-slug&quot;)","ref":"Nabo.Repo.html#c:get!/1","title":"Nabo.Repo.get!/1","type":"callback"},{"doc":"Order posts by date.Exampleposts = MyRepo.all() |&gt; MyRepo.order_by_date()","ref":"Nabo.Repo.html#c:order_by_date/1","title":"Nabo.Repo.order_by_date/1","type":"callback"}]